local _cx_layer_={}

function cx_layer_inh_mt(ch)
	ch=ch or {}
	for _i,_j in pairs(_cx_layer_) do
		ch[_i]=_j
	end
	return ch
end

function _cx_layer_:GetID(id)
	if self.id==id then return self end
	for k,v in pairs(self.chd) do
		local obj=v:GetID(id)
		if obj then return obj end
	end
end

function _cx_layer_:set_disable(disable)
	self.disable=disable
	return self
end

function _cx_layer_:DXDY(dx,dy)
	if dx then self.dx=dx end
	if dy then self.dy=dy end
	return self
end

function _cx_layer_:sort()
	table.sort(self.chd,function(a,b) return a.z<b.z end)
	for k,v in pairs(self.chd) do
		v:sort()
	end
	return self
end

function _cx_layer_:ADD(layer)
	self.chd[#self.chd+1]=layer
	return self
end

function _cx_layer_:ADDS(layers)
	for i=1,#layers do
		self.chd[#self.chd+1]=layers[i]
	end
	return self
end

function _cx_layer_:ANI(f)
	self.ani=f
	return self
end

function _cx_layer_:_update(ts)
	if self.ani then
		self:ani()
	end
end
function _cx_layer_:update(ts)
	self:_update(ts)
	for k,v in pairs(self.chd) do
		v:update(ts)
	end
end

function _cx_layer_:_draw(x,y)
end
function _cx_layer_:draw(x,y)
	if self.disable then return end
	x=x+self.x+self.dx
	y=y+self.y+self.dy
	local chd=self.chd
	local pos=1
	for i=1,#chd do
		local obj=chd[i]
		if obj.z>=0 then break end
		obj:draw(x,y)
		pos=i+1
	end
	self:_draw(x,y)
	for i=pos,#chd do
		local obj=chd[i]
		obj:draw(x,y)
	end
end

function CXLAYER(id,z,x,y,mt)
	local self = setmetatable({id=id,z=z,x=x,y=y,dx=0,dy=0,chd={}},{__index=mt or _cx_layer_})
	return self
end

local _cx_layer_label=cx_layer_inh_mt()

function _cx_layer_label:_draw(_x,_y)
	local label=self.txtdef
	if label.outlinecol then
		local s,olc,opt,size,fname=label[1],label.outlinecol,table.unpack(label,3,5)
		for x=-1,1 do
			for y=-1,1 do
				drawTxt_h(s,_x+x,_y+y,olc,opt,size,fname)
			end
		end
	end
	drawTxt_h(label[1],_x,_y,table.unpack(label,2,5))
end

function CXLAYER_LABEL(id,z,txt,x,y,col,opt,size,fname,outlinecol)
	local self = CXLAYER(id,z,x,y,_cx_layer_label)
	self.txtdef={txt,col,opt,size,fname}
	if outlinecol then
		self.txtdef.outlinecol=outlinecol
	end
	return self
end

local _cx_layer_img=cx_layer_inh_mt()

function _cx_layer_img:_draw(x,y)
	local img=self.imgdef
	img_drawex(img[1],x,y,table.unpack(img,2,6))
end

function CXLAYER_IMG(id,z,x,y,img,anch,sx,sy,sw,sh)
	local self = CXLAYER(id,z,x,y,_cx_layer_img)
	self.imgdef={img,anch,sx,sy,sw,sh}
	return self
end

local _cx_layer_rot=cx_layer_inh_mt()

function _cx_layer_rot:draw(x,y)
	if self.disable then return end
	local rotdef=self.rotdef
	local oldscr=statctl('scrm',0)
	local cx,cy,cw,ch=clip(table.unpack(rotdef,1,4))

	rectcls(rotdef[1],rotdef[2],rotdef[1]+rotdef[3],rotdef[2]+rotdef[4],0)
	--rectfill(rotdef[1],rotdef[2],rotdef[1]+rotdef[3],rotdef[2]+rotdef[4],blue)

	ux=rotdef[1]+rotdef[3]//2
	uy=rotdef[2]+rotdef[4]//2
	local chd=self.chd
	local pos=1
	for i=1,#chd do
		local obj=chd[i]
		if obj.z>=0 then break end
		obj:draw(ux,uy)
		pos=i+1
	end
	self:_draw(ux,uy)
	for i=pos,#chd do
		local obj=chd[i]
		obj:draw(ux,uy)
	end

	clip(cx,cy,cw,ch)
	statctl('scrm',oldscr)
	rotspr(rotdef[1],rotdef[2],rotdef[3],rotdef[4],x+self.x+self.dx,y+self.y+self.dy,rotdef[5],rotdef[6],rotdef[7])
end

function CXLAYER_ROT(id,z,x,y,sprx,spry,sprw,sprh,angle,zoomx,zoomy)
	local self = CXLAYER(id,z,x,y,_cx_layer_rot)
	self.rotdef={sprx,spry,sprw,sprh,angle,zoomx,zoomy}
	return self
end 